{Mutual Assured Distruction}
{v0.1                      }
{Future Tech Software      }
{by Derek Konigsberg       }

{--------------------------------------------------------------------------}

{declare program name}
program MAD;

{--------------------------------------------------------------------------}

{declare included units}
uses
 crt,dos,display,mtypes;

{--------------------------------------------------------------------------}
{draw the title screen}

procedure title;
begin
 textbackground(BLACK);
 clrscr;
 textbackground(BLUE);
 textcolor(RED);
 frame(2,2,79,24,RED,BLUE);
 gotoxy(10,10);
 textcolor(WHITE);
 write('M');
 textcolor(RED);
 write('utual');
 gotoxy(10,11);
 textcolor(WHITE);
 write('A');
 textcolor(RED);
 write('ssured');
 gotoxy(10,12);
 textcolor(WHITE);
 write('D');
 textcolor(RED);
 write('istruction');
 textcolor(WHITE);
 writexy(4,15,'v0.1');
 gotoxy(45,22);
 write('Press any key to continue...');
 readkey;
end;

{--------------------------------------------------------------------------}
{clear the action que for all players}

procedure queClear;
var
 i,j:integer;
begin
 for i:=1 to numply do
 begin
  for j:=1 to 50 do
   with player[i].que[j] do
   begin
    item:=0;
    quantity:=0;
    action:=0;
    o_cont:=0;
    o_region:=0;
    d_cont:=0;
    d_region:=0;
   end;
  player[i].qnum:=0;
 end;
end;

{--------------------------------------------------------------------------}
{sort the action que for all players according to the order of events}

procedure queSort;
var
 i,j,k:integer;
 temp:quelist;
begin
 for i:=1 to numply do
 begin
  temp:=player[i].que;
  j:=1;
  k:=1;
  while (j <= player[i].qnum) do
  begin
   if temp[j].item=NICBMS then
   begin
    player[i].que[k]:=temp[j];
    inc(k);
   end;
   inc(j);
  end;
  j:=1;
  while (j <= player[i].qnum) do
  begin
   if temp[j].item=NNICBMS then
   begin
    player[i].que[k]:=temp[j];
    inc(k);
   end;
   inc(j);
  end;
  j:=1;
  while (j <= player[i].qnum) do
  begin
   if temp[j].item=ARMIES then
   begin
    player[i].que[k]:=temp[j];
    inc(k);
   end;
   inc(j);
  end;
 end;
end;

{--------------------------------------------------------------------------}
{setup the information for the players}

procedure players;
var
 ch:char;
 i,j:integer;
begin
 restorecursor;
 textbackground(BLACK);
 clrscr;
 frame(4,4,24,7,WHITE,BLUE);
 gotoxy(6,5);
 write('How many players?');
 gotoxy(6,6);
 textbackground(BLACK);
 write('         ');
 textbackground(BLUE);
 textcolor(YELLOW);
 write(' (max 4)');
 gotoxy(6,6);
 textbackground(BLACK);
 ch:=' ';
 numply:=0;
 while ch <> Chr(13) do
 begin
  ch:=readkey;
  if ch<>Chr(13) then
   i:=Ord(ch)-48;
  if (i>=2) and (i<=4) then
  begin
   gotoxy(6,6);
   write(ch);
   numply:=i;
  end;
  if (ch=Chr(13)) and (numply=0) then
   ch:=' ';
 end;
 clrscr;
 for i:=0 to numply-1 do
 begin
  frame(1+(i*10),1+(i*5),20+(i*10),4+(i*5),WHITE,BLUE);
  gotoxy(2+(i*10),2+(i*5));
  write('Player ',i+1,':');
  inptext(player[i+1].name,2+(i*10),20+(i*10),3+(i*5));
 end;
 for i:=1 to numply do
 begin
  player[i].money:=20000000;
  player[i].pu:=20000;
  player[i].intelsat[1]:=false;
  player[i].intelsat[2]:=false;
  player[i].intelsat[3]:=false;
  player[i].intelsat[4]:=false;
  for j:=NORTH to CENTER do
  begin
   board[i].own[j]:=i;
   board[i].armies[j]:=10;
   board[i].factories[j]:=10;
   board[i].ABMs[j]:=5;
   board[i].NICBMs[j]:=0;
   board[i].NNICBMs[j]:=2;
  end;
 end;
 queClear;
 hidecursor;
end;

{--------------------------------------------------------------------------}
{display a continent and some of its contents}

procedure viewcontinent(cont:continent);
var
 i:integer;
begin
 textbackground(BLACK);
 clrscr;
 frame(1,4,15,21,WHITE,cont.own[WEST]+1);
 gotoxy(3,5);
 write('WEST');
 gotoxy(2,8);
 write('Factories:');
 gotoxy(2,9);
 write(cont.factories[WEST]);
 gotoxy(2,11);
 write('Armies:');
 gotoxy(2,12);
 write(cont.armies[WEST]);

 frame(16,4,35,9,WHITE,cont.own[NORTH]+1);
 gotoxy(18,5);
 write('NORTH');
 gotoxy(17,7);
 write('Factories: ',cont.factories[NORTH]);
 gotoxy(17,8);
 write('Armies:    ',cont.armies[NORTH]);

 frame(16,10,35,15,WHITE,cont.own[CENTER]+1);
 gotoxy(18,11);
 write('CENTER');
 gotoxy(17,13);
 write('Factories: ',cont.factories[CENTER]);
 gotoxy(17,14);
 write('Armies:    ',cont.armies[CENTER]);


 frame(16,16,35,21,WHITE,cont.own[SOUTH]+1);
 gotoxy(18,17);
 write('SOUTH');
 gotoxy(17,19);
 write('Factories: ',cont.factories[SOUTH]);
 gotoxy(17,20);
 write('Armies:    ',cont.armies[SOUTH]);


 frame(36,4,50,21,WHITE,cont.own[EAST]+1);
 gotoxy(38,5);
 write('EAST');
 gotoxy(37,8);
 write('Factories:');
 gotoxy(37,9);
 write(cont.factories[EAST]);
 gotoxy(37,11);
 write('Armies:');
 gotoxy(37,12);
 write(cont.armies[EAST]);
end;

{--------------------------------------------------------------------------}
{draw data in a region specified in the dispregion procedure}

procedure dispdata(cont,area,num:integer);
var
 data:string;
begin
 str(num,data);
 if cont = 1 then
  case area of
   WEST  : writexy(2,3,data);
   NORTH : writexy(7,2,data);
   CENTER: writexy(7,5,data);
   SOUTH : writexy(7,8,data);
   EAST  : writexy(16,3,data);
  end;
 if cont = 2 then
  case area of
   WEST  : writexy(63,3,data);
   NORTH : writexy(68,2,data);
   CENTER: writexy(68,5,data);
   SOUTH : writexy(68,8,data);
   EAST  : writexy(77,3,data);
  end;
 if cont = 3 then
  case area of
   WEST  : writexy(2,17,data);
   NORTH : writexy(7,17,data);
   CENTER: writexy(7,20,data);
   SOUTH : writexy(7,23,data);
   EAST  : writexy(16,17,data);
  end;
 if cont = 4 then
  case area of
   WEST  : writexy(63,17,data);
   NORTH : writexy(68,17,data);
   CENTER: writexy(68,20,data);
   SOUTH : writexy(68,23,data);
   EAST  : writexy(77,17,data);
  end;
end;

{--------------------------------------------------------------------------}
{display a continental region}

procedure dispregion(cont,area,data,color:integer);
begin
 textcolor(WHITE);
 textbackground(BLUE);

 if cont = 1 then
  case area of
   WEST  : frame(1,1,5,9,WHITE,color);
   NORTH : frame(6,1,14,3,WHITE,color);
   CENTER: frame(6,4,14,6,WHITE,color);
   SOUTH : frame(6,7,14,9,WHITE,color);
   EAST  : frame(15,1,19,9,WHITE,color);
  end;

 if cont = 2 then
  case area of
   WEST  : frame(62,1,66,9,WHITE,color);
   NORTH : frame(67,1,75,3,WHITE,color);
   CENTER: frame(67,4,75,6,WHITE,color);
   SOUTH : frame(67,7,75,9,WHITE,color);
   EAST  : frame(76,1,80,9,WHITE,color);
  end;

 if cont = 3 then
  case area of
   WEST  : frame(1,16,5,24,WHITE,color);
   NORTH : frame(6,16,14,18,WHITE,color);
   CENTER: frame(6,19,14,21,WHITE,color);
   SOUTH : frame(6,22,14,24,WHITE,color);
   EAST  : frame(15,16,19,24,WHITE,color);
  end;

 if cont = 4 then
  case area of
   WEST  : frame(62,16,66,24,WHITE,color);
   NORTH : frame(67,16,75,18,WHITE,color);
   CENTER: frame(67,19,75,21,WHITE,color);
   SOUTH : frame(67,22,75,24,WHITE,color);
   EAST  : frame(76,16,80,24,WHITE,color);
  end;
 if data <> 0 then
  dispdata(cont,area,data);
end;

{--------------------------------------------------------------------------}
{display the board for placement}

procedure dispboard(ply:integer; item:integer);
var
 i,j:integer;
 data:plrec;
begin
 textcolor(WHITE);
 textbackground(BLUE);
 clrscr;
 for i:=1 to numply do
  for j:=NORTH to CENTER do
   case item of
    FACTORIES: data[i,j]:=board[i].factories[j];
    ARMIES   : data[i,j]:=board[i].armies[j];
    ABMS     : data[i,j]:=board[i].ABMs[j];
    NICBMS   : data[i,j]:=board[i].NICBMs[j];
    NNICBMS  : data[i,j]:=board[i].NNICBMs[j];
   end;

 for i:=1 to numply do
  for j:=NORTH to CENTER do
  begin
   if board[i].own[j]=ply then
    dispregion(i,j,data[i,j],ply+1)
   else
    dispregion(i,j,0,BLACK);
  end;
end;


{--------------------------------------------------------------------------}
{display the whole board for deployment}

procedure dispwboard(item:integer);
var
 i,j:integer;
 data:plrec;
begin
 textcolor(WHITE);
 textbackground(BLUE);
 clrscr;
 for i:=1 to numply do
  for j:=NORTH to CENTER do
   case item of
    FACTORIES: data[i,j]:=board[i].factories[j];
    ARMIES   : data[i,j]:=board[i].armies[j];
    ABMS     : data[i,j]:=board[i].ABMs[j];
    NICBMS   : data[i,j]:=board[i].NICBMs[j];
    NNICBMS  : data[i,j]:=board[i].NNICBMs[j];
   end;

 for i:=1 to numply do
  for j:=NORTH to CENTER do
   dispregion(i,j,data[i,j],board[i].own[j]+1)
end;


{--------------------------------------------------------------------------}
{place something on the board}

procedure placement(ply,item,quantity:integer);
var
 i,j,k,l,num,code:integer;
 text:string;
 data:plrec;
 list:pllist;
 ch:char;
begin
 for i:=1 to numply do
  for j:=NORTH to CENTER do
   case item of
    FACTORIES: data[i,j]:=board[i].factories[j];
    ARMIES   : data[i,j]:=board[i].armies[j];
    ABMS     : data[i,j]:=board[i].ABMs[j];
    NICBMS   : data[i,j]:=board[i].NICBMs[j];
    NNICBMS  : data[i,j]:=board[i].NNICBMs[j];
   end;

 k:=0;
 for i:=1 to numply do
  for j:=NORTH to CENTER do
  begin
   if board[i].own[j]=ply then
   begin
    inc(k);
    list[k].cont:=i;
    list[k].region:=j;
    list[k].data:=data[i,j];
   end;
  end;

 dispboard(ply,item);

 l:=1;
 dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],WHITE);

 while quantity <> 0 do
 begin

  ch:=readkey;

  if (ch = chr(75)) then
  begin
   dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],ply+1);
   if (l = 1) then
    l:=k
   else
    dec(l);
   dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],WHITE);
  end;

  if (ch = chr(77)) then
  begin
   dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],ply+1);
   if (l = k) then
    l:=1
   else
    inc(l);
   dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],WHITE);
  end;

  if (ch = chr(13)) then
  begin
   while 1=1 do
   begin
    frame(21,10,60,15,WHITE,CYAN);
    writexy(22,11,'Place how many?');
    write(' (max ',quantity,')');
    inptext(text,22,30,13);
    val(text,num,code);
    if (code = 0) and (num <=quantity) then
    begin
     list[l].data:=list[l].data+num;
     quantity:=quantity-num;
     i:=list[l].cont;
     j:=list[l].region;
     data[i,j]:=list[l].data;
     case item of
      FACTORIES: board[i].factories[j]:=data[i,j];
      ARMIES   : board[i].armies[j]:=data[i,j];
      ABMS     : board[i].ABMs[j]:=data[i,j];
      NICBMS   : board[i].NICBMs[j]:=data[i,j];
      NNICBMS  : board[i].NNICBMs[j]:=data[i,j];
     end;
     dispboard(ply,item);
     dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],WHITE);
    end;
    break;
   end;
  end;
 end;
 readkey;
end;

{--------------------------------------------------------------------------}
{remove something from the board}

procedure removal(ply,item:integer);
var
 i,j,k,l,num,code:integer;
 text:string;
 data:plrec;
 list:pllist;
 ch:char;
begin
 for i:=1 to numply do
  for j:=NORTH to CENTER do
   case item of
    FACTORIES: data[i,j]:=board[i].factories[j];
    ARMIES   : data[i,j]:=board[i].armies[j];
    ABMS     : data[i,j]:=board[i].ABMs[j];
    NICBMS   : data[i,j]:=board[i].NICBMs[j];
    NNICBMS  : data[i,j]:=board[i].NNICBMs[j];
   end;

 k:=0;
 for i:=1 to numply do
  for j:=NORTH to CENTER do
  begin
   if board[i].own[j]=ply then
   begin
    inc(k);
    list[k].cont:=i;
    list[k].region:=j;
    list[k].data:=data[i,j];
   end;
  end;

 dispboard(ply,item);

 l:=1;
 dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],WHITE);

 while ch <> chr(27) do
 begin

  ch:=readkey;

  if (ch = chr(75)) then
  begin
   dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],ply+1);
   if (l = 1) then
    l:=k
   else
    dec(l);
   dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],WHITE);
  end;

  if (ch = chr(77)) then
  begin
   dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],ply+1);
   if (l = k) then
    l:=1
   else
    inc(l);
   dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],WHITE);
  end;

  if (ch = chr(13)) then
  begin
   while 1=1 do
   begin
    frame(21,10,60,15,WHITE,CYAN);
    writexy(22,11,'Remove how many?');
    inptext(text,22,30,13);
    val(text,num,code);
    if (code = 0) and (num <= list[l].data) then
    begin
     list[l].data:=list[l].data-num;
     i:=list[l].cont;
     j:=list[l].region;
     data[i,j]:=list[l].data;
     case item of
      FACTORIES: board[i].factories[j]:=data[i,j];
      ARMIES   : board[i].armies[j]:=data[i,j];
      ABMS     : board[i].ABMs[j]:=data[i,j];
      NICBMS   : board[i].NICBMs[j]:=data[i,j];
      NNICBMS  : board[i].NNICBMs[j]:=data[i,j];
     end;
     case item of
      FACTORIES: player[ply].money:=player[ply].money+150000;
      ARMIES   : player[ply].pu:=player[ply].pu+500;
      ABMS     : player[ply].pu:=player[ply].pu+500;
      NICBMS   : player[ply].pu:=player[ply].pu+2000;
      NNICBMS  : player[ply].pu:=player[ply].pu+1000;
     end;
     dispboard(ply,item);
     dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],WHITE);
    end;
    break;
   end;
  end;
 end;
 readkey;
end;

{--------------------------------------------------------------------------}
{deploy something to attack/move}

procedure deploy(ply,item:integer);
var
 i,j,k,l,m,n,num,code:integer;
 text:string;
 data:plrec;
 list:pllist;
 ch:char;
begin
 for i:=1 to numply do
  for j:=NORTH to CENTER do
   case item of
    FACTORIES: data[i,j]:=board[i].factories[j];
    ARMIES   : data[i,j]:=board[i].armies[j];
    ABMS     : data[i,j]:=board[i].ABMs[j];
    NICBMS   : data[i,j]:=board[i].NICBMs[j];
    NNICBMS  : data[i,j]:=board[i].NNICBMs[j];
   end;

 k:=0;
 for i:=1 to numply do
  for j:=NORTH to CENTER do
  begin
   if board[i].own[j]=ply then
   begin
    inc(k);
    list[k].cont:=i;
    list[k].region:=j;
    list[k].data:=data[i,j];
   end;
  end;
   n:=k;
 for i:=1 to numply do
  for j:=NORTH to CENTER do
  begin
   if board[i].own[j] <> ply then
   begin
    if ((j=CENTER) and ((board[i].own[NORTH]=ply)or(board[i].own[SOUTH]=ply)
    or(board[i].own[WEST]=ply)or(board[i].own[EAST]=ply))) or (j<>center)then
    begin
     inc(n);
     list[n].cont:=i;
     list[n].region:=j;
     list[n].data:=data[i,j];
    end;
   end;
  end;

 dispwboard(item);

 l:=1;
 dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],WHITE);

 while ch <> chr(27) do
 begin

  ch:=readkey;

  if (ch = chr(75)) then
  begin
   dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],ply+1);
   if (l = 1) then
    l:=k
   else
    dec(l);
   dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],WHITE);
  end;

  if (ch = chr(77)) then
  begin
   dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],ply+1);
   if (l = k) then
    l:=1
   else
    inc(l);
   dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],WHITE);
  end;

  if (ch = chr(13)) then
  begin
   dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],GREEN);
   m:=1;
   while 1=1 do
   begin
    ch:=readkey;

    if (ch = chr(75)) then
    begin
     dispregion(list[m].cont,list[m].region,data[list[m].cont,list[m].region],board[list[m].cont].own[list[m].region]+1);
     if (m = 1) then
      m:=n
     else
      dec(m);
     dispregion(list[m].cont,list[m].region,data[list[m].cont,list[m].region],WHITE);
    end;

    if (ch = chr(77)) then
    begin
     dispregion(list[m].cont,list[m].region,data[list[m].cont,list[m].region],board[list[m].cont].own[list[m].region]+1);
     if (m = n) then
      m:=1
     else
      inc(m);
     dispregion(list[m].cont,list[m].region,data[list[m].cont,list[m].region],WHITE);
    end;

    if (ch = chr(13)) then
    begin
     dispregion(list[m].cont,list[m].region,data[list[m].cont,list[m].region],RED);
     break;
    end;
   end;

   while 1=1 do
   begin
    frame(21,10,60,15,WHITE,CYAN);
    writexy(22,11,'Deploy how many?');
    write(' (max ',data[list[l].cont,list[l].region],')');
    inptext(text,22,30,13);
    val(text,num,code);
    if (code = 0) and (num <=data[list[l].cont,list[l].region]) then
    begin
     list[l].data:=list[l].data-num;
     i:=list[l].cont;
     j:=list[l].region;
     data[i,j]:=list[l].data;

     inc(player[ply].qnum);

     player[ply].que[player[ply].qnum].item:=item;
     player[ply].que[player[ply].qnum].quantity:=num;
     player[ply].que[player[ply].qnum].o_cont:=list[l].cont;
     player[ply].que[player[ply].qnum].o_region:=list[l].region;
     player[ply].que[player[ply].qnum].d_cont:=list[m].cont;
     player[ply].que[player[ply].qnum].d_region:=list[m].region;

     if board[list[m].cont].own[list[m].region]=ply then
      player[ply].que[player[ply].qnum].action:=MOVE
     else
      player[ply].que[player[ply].qnum].action:=ATTACK;

     case item of
      FACTORIES: board[i].factories[j]:=data[i,j];
      ARMIES   : board[i].armies[j]:=data[i,j];
      ABMS     : board[i].ABMs[j]:=data[i,j];
      NICBMS   : board[i].NICBMs[j]:=data[i,j];
      NNICBMS  : board[i].NNICBMs[j]:=data[i,j];
     end;
     dispwboard(item);
     dispregion(list[l].cont,list[l].region,data[list[l].cont,list[l].region],WHITE);
    end;
    break;
   end;
  end;
 end;
 readkey;
end;

{--------------------------------------------------------------------------}
{implement the "spy phase"}

procedure spyphase(ply:integer);
var
 mdat:itemlist;
 temp,temp1,i:integer;
begin
 while 1=1 do
 begin
  textcolor(WHITE);
  textbackground(BLUE);
  clrscr;
  centertext(player[ply].name,2);
  centertext('>>>Spy Phase<<<',4);
  mdat[1]:='View spy satelite telemetry';
  mdat[2]:='Launch spy satelite';
  mdat[3]:='Finish phase';
  mdat[4]:='*';
  temp:=menu(mdat,20,6,60,16,RED,CYAN);
  if temp=1 then
  begin
   while 1=1 do
   begin
    for i:=1 to 4 do
    begin
     if player[ply].intelsat[i]=true then
     begin
      mdat[i]:='View continent';
     end
     else
      mdat[i]:='No spy satellite in position';
    end;
    mdat[i+1]:='*';
    temp1:=menu(mdat,20,6,60,16,RED,CYAN);
    if temp1=0 then
     break;
    if player[ply].intelsat[temp1]=true then
    begin
     viewcontinent(board[temp1]);
     readkey;
     textbackground(BLUE);
     clrscr;
    end;
   end;
  end;
  if temp=2 then
  begin
   while 1=1 do
   begin
    for i:=1 to numply do
    begin
     if player[ply].intelsat[i]=true then
      mdat[i]:='Spy satelite already in position'
     else
      mdat[i]:='Launch spy satelite (5,000 PUs)';
    end;
    mdat[numply+1]:='*';
    temp1:=menu(mdat,20,6,60,16,RED,CYAN);
    if temp1=0 then
     break;
    if (player[ply].intelsat[temp1]=false) and (player[ply].pu >=5000) then
    begin
     player[ply].intelsat[temp1]:=true;
     player[ply].pu:=player[ply].pu-5000;
    end;
   end;
  end;
  if temp=3 then
   exit;
 end;
end;

{--------------------------------------------------------------------------}
{implement the "financial phase"}

procedure finphase(ply:integer);
var
 mdat:itemlist;
 temp,code,num,i,j,k,taxes:integer;
 m:real;
 text:string;
begin
 k:=0;
 for i:=1 to numply do
  for j:=NORTH to CENTER do
   if board[i].own[j]=ply then
    k:=k+1;
 m:=(k*1000000);
 player[ply].money:=player[ply].money+round(m);
 k:=0;
 for i:=1 to numply do
  for j:=NORTH to CENTER do
   if board[i].own[j]=ply then
    k:=k+board[i].factories[j];
 player[ply].pu:=player[ply].pu+(k*100);
 while 1=1 do
 begin
  textcolor(WHITE);
  textbackground(BLUE);
  clrscr;
  centertext(player[ply].name,2);
  centertext('>>>Financial Phase<<<',4);
  frame(1,6,40,24,WHITE,BROWN);
  gotoxy(2,7);
  write('Money:             $',pnum(player[ply].money));
  gotoxy(2,8);
  write('Production units:  ',pnum(player[ply].pu));
  gotoxy(1,9);
  write('Ķ');
  gotoxy(2,10);
  write('Factories:         ',pnum(k));
  gotoxy(2,11);
  write('PU mfg. rate:      ',pnum((k*100)),' PU/yr');
  gotoxy(1,12);
  write('Ķ');
  gotoxy(2,13);
  write('Income from taxes: $',pnum(trunc(int(m))));
  mdat[1]:='Buy factories';
  mdat[2]:='Sell factories';
  mdat[3]:='Buy PUs';
  mdat[4]:='Sell PUs';
  mdat[5]:='Finish phase';
  mdat[6]:='*';
  temp:=menu(mdat,50,6,80,15,WHITE,BROWN);
  if temp = 1 then
  begin
   frame(50,17,80,22,WHITE,CYAN);
   gotoxy(51,18);
   write('Buy how many?');
   gotoxy(51,19);
   write('(max ',(player[ply].money DIV 300000):1,')');
   inptext(text,51,61,20);
   val(text,num,code);
   if code <> 0 then
    break;
   player[ply].money:=player[ply].money-(num*300000);
   placement(ply,FACTORIES,num);
  end;
  if temp = 2 then
  begin
   removal(ply,FACTORIES);
   k:=0;
   for i:=1 to numply do
    for j:=NORTH to CENTER do
     if board[i].own[j]=ply then
      k:=k+board[i].factories[j];
  end;
  if temp = 3 then
  begin
   frame(50,17,80,22,WHITE,CYAN);
   gotoxy(51,18);
   write('Buy how many?');
   gotoxy(51,19);
   write('(max ',(player[ply].money DIV 100):1,')');
   inptext(text,51,61,20);
   val(text,num,code);
   if code <> 0 then
    break;
   player[ply].money:=player[ply].money-(num*100);
   player[ply].pu:=player[ply].pu+num;
  end;
  if temp = 4 then
  begin
   frame(50,17,80,22,WHITE,CYAN);
   gotoxy(51,18);
   write('Sell how many?');
   gotoxy(51,19);
   write('(max ',pnum(player[ply].pu),')');
   inptext(text,51,61,20);
   val(text,num,code);
   if code <> 0 then
    break;
   player[ply].money:=player[ply].money+(num*50);
   player[ply].pu:=player[ply].pu-num;
  end;
  if temp = 5 then
   exit;
 end;
end;

{--------------------------------------------------------------------------}
{implement the "production phase"}

procedure prodphase(ply:integer);
var
 mdat:itemlist;
 temp:integer;
 text:string;
 num,code:integer;
 i,j,k:integer;
begin
 while 1=1 do
 begin
  textcolor(WHITE);
  textbackground(BLUE);
  clrscr;
  centertext(player[ply].name,2);
  centertext('>>>Production Phase<<<',4);
  mdat[1]:='Enlist armies';
  mdat[2]:='Buy anti-missile batteries';
  mdat[3]:='Buy conventional ICBMs';
  mdat[4]:='Buy thermonuclear ICBMs';
  mdat[5]:='Finish phase';
  mdat[6]:='*';
  temp:=menu(mdat,20,6,60,16,WHITE,RED);
  if temp = 1 then
  begin
   frame(20,18,60,22,WHITE,CYAN);
   gotoxy(21,19);
   write('Enlist how many?');
   gotoxy(21,20);
   write('(max ',(player[ply].pu DIV 1000):1,')');
   inptext(text,21,31,21);
   val(text,num,code);
   if code <> 0 then
    exit;
   player[ply].money:=player[ply].pu-(num*1000);
   placement(ply,ARMIES,num);
  end;
  if temp = 2 then
  begin
   frame(20,18,60,22,WHITE,CYAN);
   gotoxy(21,19);
   write('Buy how many?');
   gotoxy(21,20);
   write('(max ',(player[ply].pu DIV 1000):1,')');
   inptext(text,21,31,21);
   val(text,num,code);
   if code <> 0 then
    exit;
   player[ply].money:=player[ply].pu-(num*1000);
   placement(ply,ABMS,num);
  end;
  if temp = 3 then
  begin
   frame(20,18,60,22,WHITE,CYAN);
   gotoxy(21,19);
   write('Buy how many?');
   gotoxy(21,20);
   write('(max ',(player[ply].pu DIV 2000):1,')');
   inptext(text,21,31,21);
   val(text,num,code);
   if code <> 0 then
    exit;
   player[ply].money:=player[ply].pu-(num*2000);
   placement(ply,NNICBMS,num);
  end;
  if temp = 4 then
  begin
   frame(20,18,60,22,WHITE,CYAN);
   gotoxy(21,19);
   write('Buy how many?');
   gotoxy(21,20);
   write('(max ',(player[ply].pu DIV 4000):1,')');
   inptext(text,21,31,21);
   val(text,num,code);
   if code <> 0 then
    exit;
   player[ply].money:=player[ply].pu-(num*4000);
   placement(ply,NICBMS,num);
  end;
  if temp = 5 then
   break;
 end;
end;

{--------------------------------------------------------------------------}
{implement the "attack phase"}

procedure attackphase(ply:integer);
var
 mdat:itemlist;
 temp:integer;
begin
 while 1=1 do
 begin
  textcolor(WHITE);
  textbackground(BLACK);
  clrscr;
  centertext(player[ply].name,2);
  centertext('>>>Attack Phase<<<',4);
  mdat[1]:='Attack/move armies';
  mdat[2]:='Launch conventional ICBMs';
  mdat[3]:='Launch thermonuclear ICBMs';
  mdat[4]:='Finish phase';
  mdat[5]:='*';
  temp:=menu(mdat,20,6,60,16,WHITE,RED);
  if temp=1 then
  begin
   deploy(ply,ARMIES);
  end;
  if temp=2 then
  begin
   deploy(ply,NNICBMS);
  end;
  if temp=3 then
  begin
   deploy(ply,NICBMS);
  end;
  if temp=4 then
   break;
 end;
end;

{--------------------------------------------------------------------------}
{play all the events in all ques}

procedure quePlay;
var
 i,j:integer;
begin
 for i:=1 to numply do
 begin
  textbackground(BLACK);
  textcolor(WHITE);
  clrscr;
  clicktext('General ');
  clicktextln(player[i].name);
  readkey;
  for j:=1 to player[i].qnum do
  begin
   if player[i].que[j].action = MOVE then
   begin
    with player[i].que[j] do
     case item of
      ARMIES :board[d_cont].armies[d_region]:=board[d_cont].armies[d_region]+quantity;
      NICBMS :board[d_cont].NICBMs[d_region]:=board[d_cont].NICBMs[d_region]+quantity;
      NNICBMS:board[d_cont].NNICBMs[d_region]:=board[d_cont].NNICBMs[d_region]+quantity;
     end;
   end;
   if player[i].que[j].action = ATTACK then
   begin
    if player[i].que[j].item = armies then
    begin
     textbackground(BLACK);
     textcolor(WHITE);
     clrscr;
     clicktextln('TRACKNET DEFENSIVE TRACKING SYSTEM');
     clicktextln('----------------------------------');
     clicktextln('');
     clicktextln('Enemy troops incoming:');
     write(player[i].que[j].quantity);
     clicktextln(' ');
     readkey;
    end;
    if player[i].que[j].item = NICBMs then
    begin

    end;
    if player[i].que[j].item = NNICBMs then
    begin

    end;
   end;
  end;
 end;
end;

{--------------------------------------------------------------------------}
{carry out all attack orders and defences}

procedure doevents;
begin
 textbackground(RED);
 clrscr;
 textcolor(WHITE);
 centertext('ATTENTION ALL PLAYERS!!!!',2);
 centertext('-------------------------',3);
 centertext('ORDER OF EVENTS',10);
 centertext('>> Thermonuclear ICBM launches <<',12);
 centertext('>> Conventional ICBM launches  <<',13);
 centertext('>>        Army attacks         <<',14);
 writexy(2,20,'Press any key to continue...');
 readkey;
 queSort;
 quePlay;
end;

{--------------------------------------------------------------------------}
{the main program}

begin
 hidecursor;
 textbackground(BLACK);
 clrscr;
 title;
 players;
{ while 1=1 do
 begin}
  for i:=1 to numply do
  begin
   spyphase(i);
   finphase(i);
   prodphase(i);
   attackphase(i);
  end;
  doevents;
{ end;}
 readkey;
end.
